;=====================================================
;MAIN ATYPEX.DLL SOURCE CODE FILE
;=====================================================
ATX_VERSION		equ	'1.25'
NUM_NEWACTIONTYPES	equ	6

;=================================================================
format PE GUI 4.0 DLL at 1500000h
entry DllEntryPoint
;=================================================================

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this
include 'Data\BaseData_struc.inc'
include 'Data\valuesDLL.inc'
include 'Data\macros.inc'
include 'INIT_RT\_MAIN_INIT_MACROS.inc'

;=================================================================
section '.code' code readable executable
;=================================================================

DllEntryPoint:			;initializes DLL for specific EXE
	mov eax,[esp+8]
	cmp eax,DLL_PROCESS_ATTACH
	jz LoadDLLCode
	cmp eax,DLL_PROCESS_DETACH
	jz FREE_MEM_1
	mov eax,TRUE
	ret 12
;-----------------------------------
	FREE_MEM_1:		;frees possibly loaded bitmap + name(s)
	cmp [currentbitmap],0
	jz NoFreeRequired1
	   invoke LocalFree,[currentbitmap]
	NoFreeRequired1:

	cmp [CAnimal_BUF],0
	jz NoFreeCAnimalBuffer
	   invoke LocalFree,[CAnimal_BUF]
	NoFreeCAnimalBuffer:

	cmp [CAnimal_Names_INDEX],0
	jz NoFreeCAnimalINDEXBuffer
	   invoke LocalFree,[CAnimal_Names_INDEX]
	NoFreeCAnimalINDEXBuffer:

	cmp [CAnimal_Names_BUF],0
	jz NoFreeCAnimalNAMESBuffer
	   invoke LocalFree,[CAnimal_Names_BUF]
	NoFreeCAnimalNAMESBuffer:

	mov eax,TRUE
	ret 12
;-----------------------------------
include 'INIT_RT\INIT_LOGFILE.inc'

LoadDLLCode:
	mov eax,[esp+4]
	mov [DLLHandle],eax

	call CreateLogFile

	push esi
	push edi
	push ebp
	push ebx

	xor ebp,ebp		;ebp -> used for error logging

include 'INIT_RT\_DETECT_EXE.inc'

include 'INIT_RT\_MAIN_SET.inc'

ExitInit:
       pop ebx
       pop ebp
       pop edi
       pop esi
       mov eax,FALSE
       test [DLLLoadSuccessBool],1
       jnz DLLLoadError2
       mov eax,TRUE		;return load DLL success
       DLLLoadError2:
       ret 12

;=================================================================
;Main InitNewActionType initialization
include 'INAT\INAT.inc'

;Main ActionType functions (methods)
include 'ActionTypes\AT100_MXTTimed.inc'
include 'ActionTypes\AT101_MXTSet.inc'
include 'ActionTypes\AT102_LoadNewMap.inc'
include 'ActionTypes\AT103_ReloadGun.inc'
include 'ActionTypes\AT104_PlayerHealth.inc'
include 'ActionTypes\AT105_PlaySMKVideo.inc'

;Explicitly enabled hacks/cheats/other
include 'RT\_RT_MACROS.inc'
include 'RT\MXTBITE.inc'
include 'RT\TRESSTRDBG.inc'
include 'RT\SHOWMAP.inc'
include 'RT\CHEATS_LOC_MAP.inc'
include 'RT\LOADINITIALBITMAP.inc'
include 'RT\SAVEMAPSTATE.inc'
include 'RT\TIMESTAMP.inc'
include 'RT\CANIMAL_INIT_END.inc'
include 'RT\CANIMAL_MOD.inc'
include 'RT\_MAIN_CHEATS.inc'
include 'RT\CANIMAL_INFO.inc'
include 'RT\RANDOM_DINOS.inc'
include 'RT\MOD_ENDLOAD.inc'
include 'RT\RT_PROCS.inc'

;=================================================================
section '.data' data readable writeable
;=================================================================

include 'Data\GeneralData.inc'
include 'Data\EXESpecData.inc'

;=================================================================
section '.idata' import data readable writeable
;=================================================================

include 'Data\Imports.inc'

;=================================================================
section '.edata' export data readable
;=================================================================
	export 'ATYPEX.DLL',\
		INAT,'INAT'	;not used - included for compatibility only

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_BITMAP,bmps,\
		  RT_VERSION,versions

	resource bmps,\
		 100,LANG_NEUTRAL,blinkerbmp

	resource versions,\
	   1,LANG_NEUTRAL,version_info

	bitmap blinkerbmp,"BLINKER.bmp"

	version version_info,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','ATYPEX.DLL BETA',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',ATX_VERSION,\
	  'ProductVersion',ATX_VERSION,\
	  'OriginalFilename','ATYPEX.DLL'

;=================================================================
section '.reloc' fixups data discardable readable
;=================================================================
