;============================================================
;MAIN NEWACTIONTYPE INITIALIZATION CODE
;============================================================
;->must return new object in esi if initsuccess
;[ebp-4]=used for LocalAlloc object size

include 'INATmacros.inc'

;====================================================================
INAT:			;eax = AT number
;====================================================================
push ebp		;THIS STACK SETUP CANNOT BE CHANGED
mov ebp,esp
sub esp,16		;possible local values, not necessarily used
push ecx
push edx
push ebx
push esi
push edi
mov esi,[BaseData]

	sub eax,100
	cmp eax,NUM_NEWACTIONTYPES
	jnb NoNewActionType

	jmp DWORD [ATINATTable+4*eax]

NoNewActionType:
	mov eax,[NO_AT_FOUND_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	jmp eax
;====================================================================
;DWORD list
;====================================================================
ATINATTable:
	dd	_AT100Init
	dd	_AT101Init
	dd	_AT102Init
	dd	_AT103Init
	dd	_AT104Init
	dd	_AT105Init
;====================================================================
_AT100Init:
;====================================================================
ALLOCAT 28
lea eax,[AT100]
mov [edi],eax
    xor ecx,ecx
    mov eax,[DefaultSlowSpeed]
    mov edx,[DefaultInterval]
mov [edi+4],ecx
mov [edi+8],eax
mov [edi+12],edx
mov [edi+16],ecx
mov [edi+20],ecx

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Interval,1
SETVALUE value_int,4

GETVALUE Frame,2		;run only once?
SETVALUE value_bool,6

mov eax,[edi+20]
mov [edi+24],eax		;save runonce value (for re-init)

	jmp ExitINAT
;====================================================================
_AT101Init:
;====================================================================
ALLOCAT 20

lea eax,[AT101]
mov [edi],eax
mov DWORD [edi+4],0
	mov eax,[DefaultSlowSpeed]
mov DWORD [edi+8],eax
mov DWORD [edi+12],0

GETVALUE Speed,0
SETVALUE value_float,3

GETVALUE Frame,1
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT
;====================================================================
_AT102Init:
;====================================================================

GETVALUE Sample,1		;get bitmap "Sample" string first
sub esp,4
mov edi,esp
SETVALUE value_string,1

pop edi 			;edi=pointer to string (if valid)
cmp eax,6
jb NoNewActionType		;leave if no valid string

lea ebx,[edi-1]
StringLengthLoop102:
inc ebx
cmp BYTE [ebx],0
jnz StringLengthLoop102
sub ebx,edi
jz NoNewActionType		;0 length?
inc ebx 			;ebx=string length (w/null terminator)
mov [ebp-4],edi 		;string addr start

lea edx,[ebx+28]		;28 for object, the rest for string

ALLOCAT edx
lea eax,[AT102]
mov [edi],eax
    xor eax,eax
    lea edx,[edi+28]
mov [edi+4],eax
mov [edi+8],edx
mov [edi+12],eax
mov [edi+16],eax
mov [edi+20],eax
mov [edi+24],eax

MOVESTRING [edi+28],[ebp-4],ebx

GETVALUE XPos,2
SETVALUE value_float,4

GETVALUE YPos,3
SETVALUE value_float,5

GETVALUE X,4
SETVALUE value_float,6

GETVALUE Y,5
SETVALUE value_float,7

	jmp ExitINAT
;====================================================================
_AT103Init:
;====================================================================
ALLOCAT 28
lea eax,[AT103]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax
    inc eax
mov [edi+16],DWORD -1
mov [edi+20],eax

GETVALUE Ammo,0
SETVALUE value_int,3

GETVALUE AltAmmoCount,1
SETVALUE value_int,4

GETVALUE LoopCount,2
SETVALUE value_int,5

GETVALUE Frame,3
SETVALUE value_int,6

mov eax,[edi+16]
mov [edi+24],eax

	jmp ExitINAT
;====================================================================
_AT104Init:
;====================================================================
ALLOCAT 20
lea eax,[AT104]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax

GETVALUE Frame,1
SETVALUE value_float,3

GETVALUE LoopCount,2
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT
;====================================================================
_AT105Init:
;====================================================================
GETVALUE Sample,1		;get video "Sample" string first
sub esp,4
mov edi,esp
SETVALUE value_string,1

pop edi 			;edi=pointer to string (if valid)
cmp eax,6
jb NoNewActionType		;leave if no valid string

lea ebx,[edi-1]
    StringLengthLoop105:
    inc ebx
    cmp BYTE [ebx],0
    jnz StringLengthLoop105
sub ebx,edi
jz NoNewActionType		;0 length?
inc ebx 			;ebx=string length (w/null terminator)
mov [ebp-4],edi 		;string addr start

lea edx,[ebx+20]		;20 for object, the rest for string

ALLOCAT edx
lea eax,[AT105]
mov [edi],eax
    lea edx,[edi+20]
and [edi+4],DWORD 0
mov [edi+8],edx
mov [edi+12],DWORD 1

MOVESTRING [edi+20],[ebp-4],ebx

GETVALUE LoopCount,2
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT
;====================================================================
ExitINAT:
;====================================================================
	mov eax,[AT_FOUND_JUMPDEST]
mov esi,edi			;save object (address)
pop edi
add esp,4
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax

;====================================================================
UnableToAllocateMem:
;====================================================================
	mov eax,[AT_MEM_ERROR_JUMPDEST]
pop edi
pop esi
pop ebx
pop edx
pop ecx
mov esp,ebp
pop ebp
	mov ebp,[esp+18h]	;seems standard amongst ActionTypes
	jmp eax
